#include <iostream>
#include "endoscopy_annotation_xml_utility.h"

using namespace std;

void print_map(const map<string, string>& print_map, const string& begin);
void print_annotations(const map<string, vector<map<string, string>>>& annotations);

int main()
{
	const string path[] = {
		R"(..\TestData\Endo-Annotation-1.xml)",
		R"(..\TestData\Endo-Annotation-2.xml)",
		R"(..\TestData\Endo-Annotation-3.xml)",
	};

	for (const auto& i : path)
	{
		auto doc = LoadXml(i);
		cout << ":\n";
		auto user_info = ParseUserInformation(doc);
		cout << "User Information:\n";
		print_map(user_info, "\t");

		auto image_info = ParseImageInformation(doc);
		cout << "Image Information:\n";
		print_map(image_info, "\t");

		auto annotations = GetAllAnnotations(doc);
		cout << "Annotation:\n";
		print_annotations(annotations);

		cout << "\n";
	}

	auto a = getchar();
}

void print_map(const map<string, string>& print_map, const string& begin)
{
	for (auto& it : print_map)
	{
		cout << begin << it.first << " " << it.second << '\n';
	}
}

void print_annotations(const map<string, vector<map<string, string>>>& annotations)
{
	for (auto& it : annotations)
	{
		cout << "\t" << it.first << ":" << it.second.size() << "\n";
	}
}